Page MenuHomePhabricator

Discussion: Create a Central Gadget Taskforce
Closed, ResolvedPublic

Description

(Based on a common idea with @Amire80)
A lot of gadgets are used by multiple wikis, but with a autonomous cycle of life and separate maintenance.
Sometimes, you copy a gadget from a wiki to another because it is cool and, years later, you don't understand why it is not working anymore (personal experience, you have the right to laugh at me).
Some wikis, even big ones, don't have a dedicated project for gadget (and scripts) maintenance.

A central repository is needed.

Some attempts have been done:

Possible ways to implement a Central Gadget Taskforce:

This task may also help T121470: Central Global Repository for Templates, Lua modules, and Gadgets and T153332: Investigation: Global gadgets, by having people already working together.
These tasks may help: T164222: Create a tool to audit onwiki gadget code, T165981: Implement a prototype JavaScript review system for MediaWiki

Event Timeline

Restricted Application added a subscriber: Aklapper. · View Herald TranscriptMar 1 2017, 2:40 PM
Elitre added a subscriber: Elitre.Mar 3 2017, 6:23 PM
Trizek-WMF updated the task description. (Show Details)Mar 3 2017, 6:25 PM
Elitre added a subscriber: eranroz.Mar 3 2017, 6:30 PM

A possible good start would be to create Gadgets for VE/NWE.

He7d3r updated the task description. (Show Details)Mar 4 2017, 1:38 AM
Zache added a subscriber: Zache.Apr 18 2017, 7:33 AM
Qgil moved this task from Backlog to Team radar on the Developer-Advocacy board.
robkam added a subscriber: robkam.Apr 26 2017, 12:38 PM
Quiddity updated the task description. (Show Details)Apr 26 2017, 7:11 PM

Interesting. Are gadget developers (attending the Hackathon or not) being notified about this proposal?

Interesting. Are gadget developers (attending the Hackathon or not) being notified about this proposal?

It is a featured project for the hackathon. Can we advertise it more?

This looks too big IMHO. What specifically would you advertise? The kind of project that gadget devs should learn about (to be actually able to get anything done in a short amount of time) looks more like "let's make gadgets for 2017WE, here's the docs, here are the people who can code with you", and I don't think there's anything like that ready.

Interesting. Are gadget developers (attending the Hackathon or not) being notified about this proposal?

It is a featured project for the hackathon. Can we advertise it more?

Most likely by next week, we'll have a list of featured projects up on the event wiki. We'll then start promoting them to the hackathon participants, ask folks to express their interest in a project, and let us know what help they might need. Gadgethon sounds like a cool idea, we could definitely highlight it separately and this task could then be a part of it.

It is a featured project for the hackathon. Can we advertise it more?

Creating a Central Gadget Taskforce sounds like an effort that would require a discussion online first, lead by gadget developers. If that doesn't work, then ok, it is possible to propose a session at the Hackathon and see who shows up and whether there is critical mass.

I am not sure how to advertise this proposal to gadget developers. It would be easier if there would be a central repository of gadgets. ;)

It is a featured project for the hackathon. Can we advertise it more?

Creating a Central Gadget Taskforce sounds like an effort that would require a discussion online first, lead by gadget developers. If that doesn't work, then ok, it is possible to propose a session at the Hackathon and see who shows up and whether there is critical mass.

I think the opposite can be done: have a group of volunteers to define a way to create a central repository, and the ask gadgets/templates creators to challenge it. It may go faster.

I am not sure how to advertise this proposal to gadget developers. It would be easier if there would be a central repository of gadgets. ;)

Haha! The various Javascript Projects are a good first step. I'll send them messages.

He7d3r added a subscriber: He7d3r.Apr 29 2017, 5:34 PM
Trizek-WMF added a subscriber: Lea_Lacroix_WMDE.

I'll run a session, welcoming interested attendees to define how to create such a central repository. The goal is to have a proof of concept to submit to the different communities, and then create the repositories in a collaborative way.
If something needs to be developed, it would be better to do it during the Wikimania hackathon.

Qgil triaged this task as Low priority.May 4 2017, 4:39 PM
Qgil moved this task from Backlog to May on the Developer-Advocacy (Apr-Jun 2017) board.
Trizek-WMF updated the task description. (Show Details)May 9 2017, 10:08 AM

Hello! Just letting you know that you can schedule this session now for the hackathon. Instructions and scheduling can be done here:
https://www.mediawiki.org/wiki/Wikimedia_Hackathon_2017/Program#How_to_schedule_breakout_sessions

Trizek-WMF raised the priority of this task from Low to Normal.May 16 2017, 4:52 PM

The first discussion will be at the hackathon: Saturday, 15:00 - 16:00, Room Wiaschtl

0x010C added a subscriber: 0x010C.May 17 2017, 1:50 PM
Trizek-WMF updated the task description. (Show Details)May 21 2017, 2:26 PM
Nemo_bis closed this task as Resolved.May 26 2017, 6:57 AM
Nemo_bis added a subscriber: Nemo_bis.

Practically speaking, such a task force already exists for gadgets: to be part of it, you need to be a Meta-Wiki or Commons administrator proficient in JavaScript, or a global interface editor.

Documentation on how to install gadgets on your own wiki is generally contained on the gadgets themselves. If you see some gadget being copied around while it should be imported, administrators need to change its code comments/documentation and update the local copies one by one.

Hackathon Etherpad: https://etherpad.wikimedia.org/p/Hack17GadgetTaskforce

It seems the discussion was mostly about templates and modules. Local templates and modules are inextricably linked to content, so in the general case they're impossible for an outsider to maintain.

So we seems to have a consensus: we need a wiki acting as central repository (T121470), until then try to reduce duplication across wikis with the usual systems.

Qgil renamed this task from Create a Central Gadget Taskforce to Discussion: Create a Central Gadget Taskforce.May 27 2017, 8:02 AM
Qgil awarded a token.
Trizek-WMF reopened this task as Open.May 29 2017, 3:10 PM

I'm reopening the task, to track the wrap-up on the hackathon' session and define the next steps for the taskforce.

Nemo_bis removed a subscriber: Nemo_bis.Jun 1 2017, 9:45 PM

I'm reopening the task, to track the wrap-up on the hackathon' session and define the next steps for the taskforce.

@Trizek-WMF: Does somebody plan to drive discussing / defining the next steps?

I'm reopening the task, to track the wrap-up on the hackathon' session and define the next steps for the taskforce.

@Trizek-WMF: Does somebody plan to drive discussing / defining the next steps?

Yes, me. I've just been too busy to work on this this week.

Trizek-WMF closed this task as Resolved.Jun 20 2017, 1:32 PM

This central taskforce is overall useful.

It will help users and communities:

  • it can help new communities to be ready more quickly, with no need to recreate all templates
  • complicated elements can be shared over the wikis, with a central maintenance. You don't need to have a Lua guru per wiki.

It will help services to work:

  • have more common templates will facilitate translations or article creation using Wikidata (ArticlePlaceholder)
  • there is less risks of having a major gadget broke

Other points:

  • ShadowNamespaces has started a while ago. The Central Taskforce will use them when they will be ready.

Possible improvements:

  • identify the most common & import Lua modules and bundle in Scribunto
  • Wikibase installation calls Lua modules. It is possible to have an Extension that update modules on each wikis.
  • Vandalism will be reduced on major templates if they are just a Lua call, despite the fact that most main templates are not edited much.
  • gadget sandboxes, test wikis

Be careful of:

  • loosing people who will prefer to edit locally, or have a way to have local settings
  • have something too complicated

Next step: draft some best practices.

Amire80 added a comment.EditedJun 20 2017, 1:52 PM

Thanks for the summary, @Trizek-WMF.

A few more points from the conversation we had:

  • To help people remain as close as possible to editing templates locally on the wikis, the people who maintain the templates and have sysop or similar permissions, will be fast-tracked to getting +2 in the relevant repos.
  • Having this maintained as actual extension will have several advantages:
    • Localization in translatewiki.net
    • Easy installation process on any MediaWiki site.
  • Another next step is to find templates that would be relevant for such conversion:
    • Easier:
      • Language templates, such as {{lang-*}} in the English Wikipedia (see T166971) are fairly simple and ubiquitous.
      • Unit conversion (miles / kilometers, grams / ounces, etc.)
      • Coordinates.
      • Authority Control
    • Harder:
      • Infoboxes.
      • Citations.

Thank you for the additional points, @Amire80. They were not on the Etherpad, and I didn't recall everything.

Does this "central taskforce" have an info page beyond this task?

I also wonder whether this is related to @bd808's attempts to push Special Interest Groups (T164551: RfC: Adopt governance guidelines for Special Interest Groups (SIG))

Does this "central taskforce" have an info page beyond this task?

Not yet. This is included in the "draft best practices" I was mentioning.

I also wonder whether this is related to @bd808's attempts to push Special Interest Groups (T164551: RfC: Adopt governance guidelines for Special Interest Groups (SIG))

I also wonder whether this is related to @bd808's attempts to push Special Interest Groups (T164551: RfC: Adopt governance guidelines for Special Interest Groups (SIG))

I think this could be a SIG if that model sounds useful to the organizers/members. I still need to write up my strawdog proposal of what being a SIG means on the linked task though which makes promoting the idea harder...

Tgr added a subscriber: Tgr.Feb 8 2018, 6:18 AM

Hello, I was talking to @0x010C about this today during T181381. If more of you consider this is worth discussing/working during WMHack 2018, we can add the corresponding tag to this task or create another task listed to this.